The xdvik development team tries to keep step with the changes in
Paul Vojta's xdvi, but since we might not always manage to update
xdvik in time, there may be `leaps' in the version numbers.
Sometimes there are also intermediate or `patchlevel' releases of
xdvik between two releases of xdvi; these are tagged with additional
digits (e.g. `22.74.1'; up to 22.40, letters were used instead).

Versions containing major changes are marked as `beta'; these
may contain undetected bugs. Such versions shouldn't be used
by distributors.

   * 22.84.16 (2009-05-18):
	+ Fixed a problem with the distribution (texmf.cnf file wasn't
	  included).

   * 22.84.15 (2009-03-02):
	+ Fixed #2067614: Re-introduced default binding for key 0
	  which had been forgotten in previous changes
	+ Fixed #1502137 (compiler warnings on 64bit systems)
	+ Fixed some typos in the man page (ubuntu ticket #202435, see
          https://bugs.launchpad.net/ubuntu/+source/texlive-bin/+bug/202435)

   * 22.84.14:
	+ Added action "mouse-modes()" to allow customization of
	  mode specific mouse bindings.
	+ Fixed #1953028 (typo in events.c that broke fullscreen mode)
	+ Fixed #1953023 (unsigned char vs. signed char problem in
	  window ID computation that broke -unique and -sourceposition
	  on 64bit systems)
	+ Fixed #1953026 (security issue with temp file naming in xdvizilla)
	+ Don't distribute xdvizilla as binary since it's no longer needed
	  for current browsers (see discussion here:
	  http://www.tug.org/pipermail/tex-live/2008-April/015697.html)
	  The source is kept for compatibility.
	+ Updated to kpathsea version 3.4.5 (same as in texlive 2007)
	+ Fixed #1875314 (--with-system-t1lib still used headers from
	  distribution's t1lib subdir)
	+ Fixed #1888187 (Typo in help window)
	+ Fixed #1875311 (Space and backspace now keep horizontal position
	  when -keep is specified)
	+ Fixed #1875321 (Numlock key is not properly handled by translations)
	+ Fixed #1875309: Added xdg-open to browser commands
	+ Improved fix for #1819017
	+ Implemented feature request #1577926 (make mouse pointer invisible
	  in magnifier window)
	+ Merged STABLE with main branch by #ifdef'ing experimental
	  DELAYED_MKTEXPK code

   * 22.84.13:
	+ Fixed #1819017 (uint32_t conflicts with XeTeX configure)
	+ Fixed #1044891 (xdvi -unique didn't insert page into page history)
	+ Fixed #1586240 (memory corruption with full TMPDIR)
	+ Fixed #1143508/#1283438 (wrong window sizes at startup)
	+ Fixed margin flags (didn't work for the first page of a document)
	+ Fixed #1553432 (failed assertion with hyperref and html:<font> specials)
	+ Fixed #1796818 (don't use 'empty' argument for %c when no column number
	  info is available)
	+ Fixed 1815476 (use = instead of == in shell wrapper)


   * 22.84.12:
	+ Fixed a segfault bug if the default replacement font (cmr10)
  	  had fewer characters than the font being replaced.
 	+ Fixed a segfault with strcmp() when the statusline was disabled.

   * 22.84.11:
	+ IMPORTANT: The binary is now called xdvi-<toolkit> instead of
	  xdvi-<toolkit>.bin, e.g. 'xdvi-motif' instead of 'xdvi-motif.bin'.
 	  For more information on the reasons for this change, please see:
	  http://sourceforge.net/tracker/index.php?func=detail&aid=1222202&group_id=23164&atid=377580
	+ Implemented a search term history for the search window.
	+ Install signal handler for SIGUSR1 early (#1094615).
	+ Fixed a crash in htex_prescan_carry_over() (#1344956, #1188866).
	+ Fixed a crash when printing a DVI file that was read from a FIFO, as
	  was the case with Debian's xdvi.pl wrapper script (#1466262).
	+ Added more font encodings (missing encodings reported by several people).
	+ Fixed issue with translations not being installed on main window on Motif
	  (problem reported by Joost Kremers to xdvi-core).
	+ Fix for bug 1611508 (segfault with -nogrey/grey).
	+ Fix for bug 1526447 (searching for EPS files in included subdirectories).
	+ Fix for bug 1376354 (make -hush also trigger -hushstdout, add -hushbell).
	+ Fix bug with whitespace chars in Chinese fonts reported as .notdef
	  (see http://tug.org/mail-archives/tex-k/2006-October/001608.html).
	+ Fix for #1572806 (xdvi-search.el: cd into directory of .tex file
	  before invoking xdvi).
	+ Bugfix for #1530667 (hyperlinks containing parentheses don't work
	  correctly with 'hdvips' driver) contributed by  Matthias Habl.
	+ Fixed xdvizilla bug #1508963 (Solaris "file" utility doesn't
	  recognize DVI files).
	+ Fixed bug #1499566 (force focus for text input field in search
	  dialog for Xaw).
	+ Fixed bugs #1475921 and #1484561 (type errors and a case of
	  uninitialized memory); thanks to Nobuyuki Tsuchimura for
	  reporting them and providing a patch.
	+ Fix for bug #1454648: restore old behaviour of '-s 0' option
	  which was accidentally lost in rev. 1.249.2.80
	+ Resurrected 'grid mode' which had been removed in 22.73-beta1
	  (toggled via 'D'; feature request #1375576)
	+ Fixed bug #1428583 (problems with GS_DPS, reported by Ben Stern)
	+ Fixed bug #1428482 (problem with building on sparcv9, also found
          by Ben Stern)
	+ Added Ctrl/Shift bindings to the mouse wheel for zooming and
	  scrolling horizontally
	+ Fixed a bug with PK fonts not being used after loading a Type1
	  font had failed, reported by Ralf Stubner (#1363644)
	+ Fixed a crash on Solaris 10 (SPARC and AMD64) with WORD64/LONG64
	  reported by Peter Bray.
	+ Fixed a bug with reencoding reported by Staszek Wawrykiewicz
	  (#1295829): If plr10 is missing from ps2pk.map, xdvik will use
	  plr10.pfb without reencoding it instead of calling mktexpk for
	  plr10.mf which would yield the correct encoding.
	+ Replaced a failed assertion with a warning when a graphics file
 	  included by a PS special isn't readable by user.
	+ Fix for library inclusion order problem contributed by K. Berry
 	  (see http://tug.org/mailman/htdig/tex-live/2005-August/008609.html)

   * 22.84.10 (2005/04/28):
	+ Fixed zero termination bug in t1lib version number check (t1lib.ac).
	+ Render an empty character instead of terminating with failed assertion
	  if T1lib doesn't return a usable glyph (e.g. at very small
	  \magnification factors; #1184087).
	+ Made gs_timeout in psgs.c a resource instead of #define it.
	+ Make file opening work with file descriptors too, as used in
	  Debian's Perl wrapper for xdvi (#1165497).

   * 22.84.9 (teTeX-3.0):
	+ Applied Patch by Nobuyuki Tsuchimura (#1116871) to remove
	  code duplication in encodings.c.
	+ Changed --with-x-toolkit configure option to --with-xdvi-x-toolkit
	  for better interoperability with Metafont.
	+ Added a missing #if HAVE_X11_XMU_XMU_H in gui/selection.c.

   * 22.84.8 (2004/12/02):
	+ Made text selection mode and ruler mode work correctly with
	  LessTif and Motif 1.2.4 (bugfix for #997073). Special thanks
          to Svend Tollak Munkejord for helping me debugging this and
	  several of the other issues listed here.
        + Fixed an `unaligned access' warning on 64-bit architectures
          (OSF1/5.1), and some compiler warnings on Solaris/Ultrix/Tru64.
	  Many thanks to Bernhard Simon for extensive testing on Ultrix,
	  AIX and Tru64.
	+ Fixed a problem with non-default installation paths for libXpm,
	  with a lot of help from Sven de Vries.
        + Fixed a formatting problem in the man page that showed up with
	  groff-1.17.2.
	+ Fixed a problem with window geometry when `-geometry' argument
	  specifies only x/y-offset, reported by Karl Berry here:
          http://tug.org/mail-archives/tex-k/2004-November/001128.html
	+ Disabled virtual memory reallocation in T1lib (t1load.c,
	  ANSI_REALLOC_VM) that caused a segfault on OSF1/V5.1 alpha.
	+ Always install a custom X error handler which will print
  	  warning messages instead of terminating the application.
	+ Create ~/.xdvirc with permissions 0600 instead of default ones.

   * 22.84.6 (2004/11/08):
	+ Fixed a few compilation problems with HAVE_REGEX_H, strdup() vs.
	  xstrdup() and linkers not allowing multiple definitions (ULTRIX).

   * 22.84.5 (2004/10/28):
	+ Fixed bug #968127 (recursive call to file loading code due to
  	  read_events() in load_font(), which was supposed to update the
	  `loading file, may take a while' popup when fonts are created;
	  currently, this popup won't appear at all).

   * 22.84.4 (2004/09/27):
	+ Fixed bug #1002688 (race condition when toggling expert mode
	  and marking pages).
	+ Fix bug #992179 (failed assertion when DVI had been removed),
	  reported again by Ulrich Scholz.
	+ Implemented feature request #995114 (prefix argument for Ctrl-o
	  opens recent files in history).
	+ Fixed bug #1029127 (map file parser didn't understand `<[' encoding
	  file syntax)
	+ Fixed a crasher bug on PowerPC related to multiple invocations of
	  v*printf() without matching va_start()/va_end() calls, reported to
	  the tex-live mailing list by Siep Kroonenberg
          (http://tug.org/mailman/private/tex-live/2004-September/006780.html).
	
   * 22.84.3 (2004/07/15):
	+ Printing to PS or PDF didn't really use the fallback temporary file
	  when current file was corrupted (#986009; thanks to Ulrich Scholz
	  for reporting this one).
	+ Fixed href length computation error when a href started with whitespace
	  (#988934, again reported by Ulrich Scholz).
	+ Removed t1x11.o from libs/t1lib/Makefile.in as in tetex 2.96.5.20040711
	  since it broke compilation with --with-x=no

   * 22.84.1 (2004/06/26):
	+ Fixed a segfault if setlocale() call returns NULL for certain
	  locale/X library combinations (reported by Reiner Steib).
	+ Read the toolbar pixmap from build-in default (toolbar.xpm) if
 	  no file is found in the search locations.
	+ Fixed a problem with the toolbar causing BadMatch errors with visuals
	  where the xdvi window has a different depth from the root window,
	  reported by Olaf Weber on tex-live
	  (http://tug.org/mailman/private/tex-live/2004-June/006112.html).
	+ Fixed a problem with incompatible vsnprintf() implementations that
	  don't return the length of the string actually needed, also reported
	  by Olaf Weber.
	+ Added a warning if configure detects LessTif because of the bugs
	  with LessTif.

   * 22.84 (2004/06/01):
	+ Added a `Open Recent' entry to the files menu (file history is saved
	  to ~/.xdvirc). When xdvi is started without filename argument, the
	  most recent file from the history will be used (set the X resource
	  `noFileArgUseHistory' to false to get back the previous behaviour
	  of opening the file selector in that situation).
	+ Also enable the ruler lines when xdvi is started in ruler mode
	  (bug reported by Zhang Lin-Bo).
	+ Added `dvips options' field also to saving dialog (feature request
	  #942853, reported by Ulrich Scholz).
	+ Protect against integer overflow in prefix arguments (patch suggested
	  by Matt Swift in debian bug report #247848)
	+ Imported changes from non-k xdvi 22.83/22.84.
	+ Fixed another wrong string (printing vs. saving) for #939262
	+ Fixed a bug with UTF-8 conversion in text copy&paste.
	+ Fixed #940056 (Xaw version crashed when toggling expert mode and
	  at same time quickly changing pages)
	+ Added Ctrl-Home/End to forced Motif bindings for the drawing area.

   * 22.82 (2004/04/21):
	+ Implemented a text selection mode, similar to xpdf: Use Mouse-1
	  to mark a rectangular region of text in a DVI file which is put
	  into the X selection.
	+ Added a Preferences dialog for the Motif version.
	+ Use $HOME/.xdvirc to save user customization from menus, dialogs
	  and Motif preferences; new `-q' option/`noUserFile' X resource
	  inhibits reading this file.
	+ Changed semantics of `browser' command-line option/`wwwBrowser'
	  X resource: Make it override the $BROWSER or the (obsolete)
	  $WWWBROWSER environment variable; use Netscape by default if no
	  browser is specified.
	+ Fixed #939262 (Bugs when saving/printing: Title of log window was
	  `Printing' also when saving, and outfile names weren't updated
	  correctly after loading a new file).
	+ Force vertical scrollbar for Motif Printing/Saving log window.
	+ Bugfixes for a potential crash if shrink factor is changed on a page
	  with color specials, as in non-k xdvi-22.82.
	+ Fixed a bug with the ESC key to close popup windows in Motif that
	  could cause crashes when opening new popups, and implemented ESC
	  to close Xaw popup windows (feature request #919501).
	+ Updates for kpathsea/withenable.ac by Olaf Weber.
	+ Made Ctrl-+ and Alt-Ctrl-+ case insensitive (suggested by Harald
	  Koenig).
	+ Fixed Motif 1.2 compile (XmEACH_SIDE), and added/fixed configure
	  checks for -lXmu, -lXp and -lXpm linker options.
	+ Removed Xaw file selector auto raising since it could send the
	  X server into a busy loop when the file selector was over a window
	  that should always stay on top.
	+ Removed t1mapper man page install (script wasn't installed either).
	+ Fixed #926055:
	  - Default printing target not set correctly when printing window
  	    was initialized.
  	  - `-t' paper options were just appended instead of replacing the
	    existing ones.
  	  - Current directory of dvips was that of xdvi invocation instead
	    of DVI file path, causing e.g. problems with included EPS files.

   * 22.81.1 (2004/03/17):
	+ Upgrade to kpathsea 3.5.2, and use lookup in new locations
	  kpse_enc_format and kpse_type1_format for .enc files and .pfa/.pfb
	  files, respectivly. (Lookup in old locations is preserved for
	  backwards compatibility).
	+ Upgrade to t1lib version 5.0.2, and and additional off-by-one bugfix
	  for MAXPATHLEN.
	+ Added support for libtool, as in teTeX-beta, and resync'ed with
	  the teTeX sources (many thanks to Thomas Esser for helping with
	  this!)
	+ Fixed a failed assertion when pressing `Shift-r' (reload) after
	  a DVI file had been deleted (also reported by Thomas Esser), and
	  a problem with the `-unique' option not always reloading the file
	  as it should (idem).
	+ Added <ESC> key bindings to close some dialogs (suggested by Bernhard
	  Walle in #912671).
	+ Close dependent windows when parent is closed (e.g. warning popups
	  for the save dialog).
	+ Made the `editor' X resource deal correctly with quoted arguments
	  (for arguments containing spaces; see #907714).
	+ Additinally support the paper formats `letter', `ledger' and `tabloid'
	  for better dvips compatibility, suggested by Dragan Milicic.

   * 22.81 (2004/02/24):
	+ If no --with-toolkit option was given, check if Motif is available,
 	  and use it if it is; else, use Xaw. (Use --with-toolkit=xaw to override
	  this default).
	+ Problem with flashing redraw of highlighted region when partially
	  obscured by another window reported and fixed by Zhang Lin-bo.
        + Fixed #870323 (an error in the online help).
	+ Fixed #880550 (documented Ctrl-s; add default _pp suffix
	  to filenames only when saving partial files).
	+ Added an option '-findstring' for string search from the command
  	  line, similar to inverse search.
	+ Improved character name detection in string search by using
	  T1lib function T1_GetCharName().
	+ Fixed #883708 (oversplitting of forward search markers).
	+ Fixed #876815 (closing search window failed under certain conditions).
	+ Fixed a race condition with hyperlinks and browser startup that might
	  lead to `unknown op-code' crashes, reported again by Zhang Lin-Bo.
	+ Workaround for #884290 (drag&drop in file selector freezes xdvi/X)
	  by disabling drag&drop. Thanks to Bernhard Walle for reporting the bug
 	  and suggesting the workaround.
	+ Fixed #885464 (wrong parent window in message popups) by passing in parent
  	  widget.
	+ Upgraded to t1lib version 5.0.1.
	+ Implemented a simple page history (feature request #884674).
	+ Implemented hyperref specials inserted by \usepackage[dvips]{hyperref}
	  (feature request #662096).
	+ Fixed wrong page number initialization when going back a hyperlink
	  to a different file (#902073).

   * 22.78 (2003/12/12):
	+ Improved test for iconv lib to make it work on Mac OS X
	  (reported by Artemio Gonzalez Lopez,
	  http://sourceforge.net/mailarchive/forum.php?thread_id=3535253&forum_id=2244).
	+ Added more encodings for string extraction/search, reported
	  by Ulrich Scholz (#850787).
	+ Fixed a bug with redrawing the page after file had been reloaded
	  by `-watchfile', and a crash when using find while file was
	  reloaded (#850795), again reported by Ulrich Scholz (many thanks!)
	+ Force C locale when converting X resources to numbers, so that
	  `.' is used as decimal point (#855950 - many thanks to Martin Vaeth
	  for finding this bug).
	+ Fixed a bug when loading first file via the file selector,
	  reported by Dragan Milicic.
	+ Fixed a bug with inverted highlighting not working on Solaris,
	  again reported by Ulrich Scholz (#850788)
	+ Don't close file selector if opening the new DVI file failed
	  (feature request #851545, again by Ulrich Scholz).
	+ Implemented a0/a0r and other missing DIN A/B/C formats (feature
	  request #852431).
	+ Fixed wrong binding for XmDIALOG_OK_BUTTON instead of XmDIALOG_CANCEL_BUTTON
  	  in create_dialogs().
	+ Fixed a bug with hyperlinks that wrapped across several lines
	  and pointed to another page: these were highlighted as visited
	  only when region was exposed the second time.
	+ Fixed a compatibility problem with fork/vfork on Mac OS X, as in
	  xdvi-22.78.
	+ Added a `creating fonts' info window before main window is mapped
	  (just a preliminary hack, no replacement for truly asynchronous
	  font creation, since that window also feezes during font creation;
	  see also feature request #614708).
	+ Fixed a bug with width computation of initial window with
	  `-expertmode 0'
	+ Workaround by Zhang Lin-Bo for bug #856547 (presumably a
	  race condition with GS_PIXMAP_CLEARING_HACK and scanned_page_*
 	  global variables).
	
   * 22.77.3 (2003/11/25):
	+ Fixed a few compilation problems on Solaris (#827454, and
	  headers in print-internal.c).
	+ Added an option `ignore hyphenation/linebreaks' for string search.
	+ Use inverse highlighting instead of drawing bounding box,
	  as in Acroread/xpdf, implemented by Zhang Lin-Bo.
	+ Make the pagelist use physical pages by default, unless
	  `UseTeXPages' option is used.
	+ Made search settings honour the X resources for setting
	  checkboxes (suggested by Reiner Steib).
	+ Made the `Home' and `End' buttons go to the top and bottom
	  of the page, and Ctrl-Home and Ctrl-End to the first and last
	  page of a document, respectively.
	+ Added the forgotten directory texk/xdvik/texmf-alt for
	  non-current-teTeX systems.
	+ Fixed an X error with toggling fullscreen mode when
 	  -fullscreen option had been used (thanks to Zhang Lin-Bo
	  for reporting it).
	+ Fixed an off-by-one error in string backwards search that
	  had made it skip every second match for matches of length 1.
	+ Removed the -DOmega define and made Omega a runtime option that
	  is enable by default and can be disabled via the -noomega
	  command-line option or the `Omega' X resource.
	+ Removed the --disable-htex compilation option.
	+ Added support for CJK fonts when saving a file as UTF-8,
	  and when searching in a file with such fonts (many thanks
	  to Zhang Lin-Bo for providing the patches).
	+ Made toolbar.xpm obey the current window background colors.
	+ Fixed a crash when saving a DVI file with empty pages
	  in text format (again reported and fixed by Zhang Lin-Bo).
	+ Fixed a crash when opening nonexisting files via the file
	  selector in Motif (again reported by Zhang Lin-Bo).
	+ Fixed a crash with GS_PIXMAP_CLEARING_HACK when toggling
	  gs_alpha on a page with PS graphics (again reported by
	  Zhang Lin-Bo).
	+ Fixed broken `Print to file' option, and wrong page numbers
	  passed to dvips when `P' has been used to assign a different
	  page number to the current page
	+ Added string `physical pages' to print popup (#841434)
	

   * 22.77.2 (2003/10/18):
	+ Implemented support for additional file formats in save dialog: 
	  PS, PDF, DVI, and plain text (in ISO-8859-1 and UTF-8).
	+ Implemented string search in DVI files (feature request
	  #470389).
	+ Fixed an incompatibility with X11R5 (#803642; thanks to
	  Ulrich Scholz for his help with debugging this).
	+ Fixed a problem with the cursor masks on some X displays
	  (#804294, again reported and debugged by Ulrich Scholz).
	+ Fixed a problem with the initial tooltip window having
	  the wrong (too large) size on some systems (#802806; thanks
	  to Kostas Oikonomou for help with debugging this).
	+ Also dump PS header files (e.g. psfrag.pro) to partially saved
	  or printed files.
	+ Fixed a security problem (tmp race) with xdvizilla (#812600;
	  thanks very much to Thomas Esser for help with fixing this).
	+ Used another workaround for the Ghostscript `alpha' driver
	  problem with not erasing previous images: Call `erasepage'
	  explicitly for pages with PS graphics (#633420; many thanks
	  to John Bowman for providing a patch).	 
	+ Fixed a bug with --datadir or --prefix being overwritten by
	  default TEXMFMAIN if they didn't contain a valid texmf tree
	  (#814004; thanks to Han-Wen Nienhuys for reporting this).
	+ Fixed a typo in the Motif menu accelerator for set-gs-alpha()
	  (`V', not `0v', also reported by Han-Wen Nienhuys).
	+ Fixed bug #814328 (prevent Ctrl-l from changing position
	  when switching back from fullscreen mode).
	+ Fixed bug #810501 (`keep position' value was lost when resizing
	  to fullscreen had removed the scrollbars). Thanks again to
	  Ulrich Scholz for reporting these bugs.
	+ Fixed a typo in the manpage, and broken redrawing of page
	  (again reported by Ulrich Scholz, #819937).
	+ Also resolve symbolic links in the main DVI name; this should
	  improve the behaviour with inverse search, cf. #768817,
	  and the search for e.g. embedded graphics or hyperlinks.
	+ Use ',' as separator for command-line debugging options
	  instead of `|'.
	+ Fixed a linker problem with multiple definitions on Cygwin.
	  

   * 22.77.1 (2003/09/06):
	+ Fixed the support for the window manager `delete' protocol
	  for Xaw.
	+ Fixed bug #797171 (BadValue X error when toggling expert
	  mode on Solaris; thanks to Erik Frisk for helping me with
	  debugging this).
	+ Fixed a bug introduced in 22.76 with wrong argument to
	  kpse_set_program_name(), which results in kpathsearch
	  not finding font files etc. properly if SELFAUTODIR is used.
	  Reported by Erik Frisk. (And a fix to that fix, reported
	  by Dragan Milicic.)
	+ Fixed obsolete link in the `New Features' Help menu entry.

   * 22.77 (2003/08/25):
	+ Fixed bug #784204 (failed assertion with Motif at startup)
 	+ Removed the check for the DVI file inode number in forward
	  search, since (as opposed to original xdvi) xdvik expands the
	  DVI filename to a full path, so it's sufficient to match the
	  full path.
	+ Fixed bug #779521 (crashes when printing with temporary file
	  enabled; thanks to Bernhard Walle for spotting this).
	+ Fixed bug #769025 (saving the DVI file may result in a corrupted
	  copy; thanks to Ulrich Scholz for reporting and help with
	  debugging it).
	+ Always dump `literal' PS specials (starting with `!') to
	  the output file, otherwise things like draftcopy won't work
	  for partially saved DVI files.
	+ New application icons (lion with `X').

   * 22.76.1 (2003/06/28):
	+ Implemented a -watchfile option, as in gv (#547137).
	+ Implemented feature request #759865: To avoid `DVI file
	  corrupted' messages (and some race conditions with the
	  drawing routines that might result in `bad opcode' errors
	  when paging through a DVI file while it is being written by
	  TeX), xdvik now creates a backup version of the file being
	  viewed.  This file is swapped with a fresh version of the
	  original each time the original file has been written
	  completely by TeX.  The command line option `-notempfile'
	  can be used to revert to the previous behaviour (no
	  temporary file).
	+ Fixed a bug with up-or-previous() and down-or-next()
	  ignoring keep flag (which broke gs display, since that
	  relied on home()).
	+ Enabled XtAppAddTimeout() for Xaw, just like for Motif.
	+ Removed the STATUSLINE conditional compilation (which was
	  broken).
	+ Added a `pixels' ruler unit.
	+ Implemented a workaround for the `stale pixmaps' problem
	  with the gs x11alpha driver (#633420), by first drawing a
	  rectangle in background color of the size of the bounding
	  box to clear the pixmap.
	+ Fixed bugs #762621 (-sourceposition and -unique didn't fork
	  properly) and #762765 (printing/saving of marked pages was
	  broken) in the (withdrawn) version 22.76; thanks to
	  Zhang Lin-Bo and Bernhard Walle for reporting these bugs.
	+ Removed the XPM application icon used since xdvik-22.74, after it
	  became apparent that it was a plagiarized version of OzTeX's icon
	  (in an older version). Reported by OzTeX's author Andrew Trevorrow;
	  our sincere apologies to him.

   * 22.74.3 (2003/06/17):
	+ Security fix for MIME types: Escape all special characters
	  (e.g. backticks) in the filename argument to prevent execution
	  of malicious shell code when launching a MIME viewer.
	+ Fixed a bug in the up-or-previous() action (#754805; thanks
	  to Bernhard Walle), and changed the behaviour of the `keep'
	  flag so that up-or-previous() and down-or-next() ignore it
	  (after all, the ordinary up() and down() actions will already
	  keep the position, so they can be used instead if you don't
	  want the scrolling).
	+ Made XBell honour the bell volume (set e.g. by xset; #751763;
	  thanks to Bernhard Walle for reporting this).

   * 22.74.2 (2003/06/01):
	+ Fixed a bug with `.dvi' extension not being added if file had a
	  `.' in it (#743876; thanks to Markus Kohm for noting it). Now
	  the algorithm is the same as in non-k xdvi for files passed on
	  the command line. For files opened via hyperlinks, no extension
	  is added.
	+ Fixed a bug with wrong topic name in `Help' pulldown menu
	  (#743280; thanks to Bernhard Walle for reporting this).
	+ Fixed another bug with Omega .vf font searching (#746551;
	  thanks to Alexej Kryukov for reporting it).

   * 22.74.1 (2003/05/25):
	+ Fixed bug with misplaced link underlining when first character in
 	  the link is an accented composite character (#737643; thanks to
 	  Christian Ullrich for spotting this).
	+ Made forward search also work when file had been changed
	  and not yet reloaded (#738387).
	+ Fixed typos in `-expertmode' description in man page
	  (followups to #737019).
	+ Fixed a compilation problem when --disable-t1lib is used
	  (thanks to Ross Alexander for providing patches).
	+ Fixed a bug with `-s n' argument not working when -fullscreen
	  is given as well, reported by Zhang Lin-Bo.
	+ Fixed a bug with forward search not warning when it hadn't found
	  the file name in the specials.
	+ Made forward search canonicalize all `../', `./' and `//' in
	  the `-sourceposition' argument and in the source specials.
	+ Fixed a bug with window size not being reset correctly when
	  activating expert mode in fullscreen mode (Xaw).
	+ Added a help topic for `ruler mode'.
	+ Fixed a bug with the icon and Xaw menu code causing
	  BadMatch X errors (#740982).
	+ Setting mouse translations in Motif's `mainTranslations'
	  erroneously disabled the default pagelist translations (reported
	  by Zhang Lin-Bo).
	+ Made usage() output the options in sorted order (thanks to
	  Nelson Beebe for the patch).
	+ Added a `-unique' option (as in KDVI) for loading a new file
 	  into a running instance of xdvik.
	+ Fixed a bug with the Motif `PS' options menu (#743085; thanks to
	  Bernhard Walle for finding this).
	+ Fixed a bug with xdvi always appending a `.dvi' extension even if
	  the file already had an extension (#743182; thanks to David Feest
	  for noting this).
	+ Fixed two bugs with compilation under Cygwin (-lXpm linker option
	  too early, and MAX() not defined in xaw_men.c; thanks to Geoffrey
	  Vallis for reporting these).
	+ Fixed a bug with scroll_page_if_needed() being called with wrong
	  arguments if forward search hadn't found a glyph and used the
	  special hotspot instead.
	
   * 22.74 (2003/05/14):
	+ New option/X resource `-expertmode <n>' option replaces
          `-statusline', `-toolbar' (and effectively also
  	  `-expert', which is only supported for backwards
	  compatibility). This should fix bug #737019 and make
	  the interoperation of the various expert settings more
	  evident.

   * 22.74-beta4 (2003/05/13):
	+ Fixed a bug with Omega and T1fonts (thanks to Hossein
	  Movahhedian for reporting it).
	+ Fixed a bug with t1lib not correctly setting dvi_adv
	  for .notdef chars (thanks to Zhang-Lin Bo for spotting it
	  and providing a patch).
	+ Added configure check for including `-lXpm' option.
	+ Fixed a bug with tooltips sometimes popping up without
	  the pointer being over them.
        + Fixed a bug with the -statusline option causing a segfault
	  when toggling -expert mode (#721807, thanks to Axel Riese).
        + Expert mode now also removes the scrollbars (#718224);
	  menu bar/status line are togglable independently.

   * 22.74-beta2 (2003/03/27):
	+ Added Paul's fix for the Solaris core dump problem, and
	  re-enabled the Motif timer fix for #674992. (Special thanks
	  to Dragan Milicic for help with debugging this.)
	+ Fixed a bug with the NumLock key disabling lowercase
	  key accelerators (#708935; thanks to Diego Santa Cruz
	  for spotting this.)
	+ Replaced MIMELIBDIR and MAILCAPDIR by the more standard
	  path definitions EXTENSIONMAPS and MAILCAPS (RFC 1343).
	  Mailcap parsing now honours the `test=' and `needsterminal'
	  fields.
	+ Improved `Usage' output by showing the option that hadn't
	  been recognized (suggested by Gabriel Zachmann).
	+ Fixed bug that instance that last had focus wasn't used for
  	  forward search when there were several instances of xdvi
	  displaying the same file (#619070).
	+ Fixed xdvizilla permissions on install (#705158).
	+ Fixed a bug with the OLD_XAW detection in the configure script
	  (reported by Reiner Steib).
	+ Made hyperlinks also work with image anchors. (Thanks to
	  Gabriel Zachmann for spotting this.)

   * 22.74-beta1 (2003/03/20):
	+ Reverted change for bug #674992 since it causes core dumps
	  on Solaris.
	+ Fixed wrong values for b6(r) and b7(r) paper sizes.
	+ Added warning about not implemented `hdvips' specials
	+ Fixed bug with PgUp/PgDown key (#610206; thanks to
          Ingo Krabbe for finding the fix).
	+ Fixed a const/_Xconst mismatch (#693647; thanks to
	  Matthias Koeppe for spotting it).
	+ fixed a few hyperref bugs with links of the form
          file:foo#target not working properly (#693306; thanks
	  to Kostas Oikonomou for finding this), and a memory
	  corruption caused by the -anchorposition argument.
	+ Upgraded to kpathsea 3.4.5.
	+ New layout for help window (topics list in left pane).

   * 22.73-beta1 (2003/02/23):
	+ Fixed bug with Motif print log hanging (#674992, as in
	  xdvi-22.72), and another race condition with the print
 	  process (as in xdvi-22.73).
	+ Fixed segfault that happened when starting without PS rendering
	  and switching it on later (#684880)
	+ Fixed a bug with underlines positioned too low on wrapped hyperlinks
	  (#685652)
	+ Made text fields in print dialog resize when window is resized.
	+ Made popups respect the window manager closing/destroy action
	+ Print command now may contain pipes (#685235).
	+ Added resources `dvipsHangTime' and `dvipsFailHangTime' for
	  customizing the time the dvips print log remains open
	  (#684620).
	+ Implemented simple but hopefully effective `ruler mode'
	  (feature request #525129).
	+ Removed the old `grid' mode, which didn't have any real
	  purpose at all.
	+ Fixed description of the `-pause' option in the man page.

   * 22.71-beta1 (2003/02/10):
        + New Xaw GUI layout: pulldown menus instead of buttons,
	  added a page list for easier navigation.
	+ New Motif GUI layout, including a toolbar and a page list.
	+ Removed libwww; use web browser instead to retrieve
	  remote documents.
        + Added support for color specials (as in xdvi-22.50), and
	  colored hyperlinks.
        + Added support for papersize specials (as in xdvi-22.66).
        + Added page list for easier navigation.
        + Added `Print' (as in xdvi-22.53) and `Save' dialogs.
	+ Added a fullscreen mode (works reliably with Motif only)
	  and a simple `pause' feature
	+ Added string debugging options (e.g. `-debug T1').
	+ Swapped the DBG_PS (64) and DBG_OPEN (32) debugging options,
	  so that the kpathsea options now are a continuous range.

   * 22.40y1 (2003/08/24):
	+ Fixed a typo in xdvi.c and in the man page (X resource is
	  called t1lib, not not1lib). Reported to debian-tetex-maint
	  by Matt Swift.
	+ Fixed a segfault occuring when loading nonexistent graphics
	  files if the filename or PSfile special contains `:' (#793395;
	  many thanks to Frank Küster for helping me debugging this).
	+ NOTE: 22.40y is now considered `frozen' and will not be further
	  developed; only major bugs (which we don't expect at this point)
	  will be fixed. Users and distributors are asked to switch to the
	  22.7x branch instead.

   * 22.40y (2003/06/06):
	+ Fixed a bug with Omega .vf font searching (#746551);
	  as in 22.74.2.

   * 22.40x (2003/04/23):
	+ Fixed a bug with .tfm files not being produced for
	  Type1 fonts for which mf sources exist, posted to dctt
	  (<slrnbaaj4g.1h4.Bernhard.Walle@news.bwalle.de>).

   * 22.40w (2003/04/06):
	+ Fixed wrong values for b6(r) and b7(r) paper sizes
	+ Added warnings about not implemented `hdvips' specials,
	  and when requesting .notdef glyphs from a type1 font
	+ Added executable permissions to xdvizilla (#705158)
	+ Fixed a memory corruption bug when opening links to
	  local files fails (#715793)

   * 22.40v (2003/02/01):
	+ Replaced all strdup() instances by xstrdup().
	+ Fixed a compatibility problem with AIX3 in xserver-info.c.
	+ Some documentation changes (README.t1fonts, README.t1mapper).

   * 22.40u (2003/01/18):
	+ Fixed bug #669426 (scrolling the message popups could
	  result in BadMatch X Errors in case xdvi's color depth was
	  larger than the default depth of the screen).
	+ Updated to kpathsea 3.4.4.
	+ Some minor changes in documentation and status messages.

   * 22.40t (2002/12/27):
	+ Fixed some prototype declarations.
	+ Made shell command in xdvi-search.el also work with (t)csh
	  (#649173).

   * 22.40s (2002/11/30):
	+ Update for changed EPS handling in ghostscript 8.00,
	  which had caused previous xdvi(k) versions to hang (#644702).
	+ Replaced the startxdvi script by internal subshell handling
	  in xdvi-search.el, as suggested by Thomas Gerds
	  <gerds@paracelsus.fdm.uni-freiburg.de>.

   * 22.40r (2002/11/14):
	+ Prevent the magnifier from popping up in the button panel.
	+ Removed vsnprintf() from wwwfetch.c.
	+ Fixed return value in xdvi_exit().

   * 22.40q (2002/11/12):
	+ Fixed broken configure check for memicmp().
	+ Fixed a glitch in the fontname hash table lookup.
	+ Fixed a broken prototype with display postscript.

   * 22.40p (2002/11/10):
	+ Fixed --version and --help options (#626569).
	+ Fixed a bug with TT fonts in X giving an error with the file
	  selector (#627607)
	+ Used kpathsea hash table to speed up processing of large .map
 	  files.
	+ Added help page on mouse buttons.
	+ Added X server info for ease of debugging.

   * 22.40o (2002/10/17):
	+ More changes for ANSI C; fixed a few compilation problems
	  on Tru64 v5.1, HP-UX-10.20 and Mac OS X.
        + Upgraded to kpathsea v.3.3.8, and libwww version 5.4.0.
	+ Show numerical prefix in the statusline.
	+ Fixed a bug with `FIXME_ps_lock' not being defined when
	  configuring "with-ps=dps" (thanks to Norman Wattenberg
	  for reporting and fixing it).
	+ Improved warnings about incorrect papersize options.
	+ New actions do-href() and do-href-newwindow() to allow
 	  binding a mouse event independent of magnifier binding.
	+ Some additions to the man page.
	+ Fixed bug #518761: Xdvik won't exit(1) any more when
	  there had been a problem parsing a Type1 encoding or font file.
	+ Fixed bug #619632: try Type1 fallback first, then PK
  	  fallback, and generate PK fallback if it's not already present.
	+ Added a wrapper script `xdvizilla' that makes xdvi act as a
	  Mozilla helper application, which can also deal with .tar files.

   * 22.40n (2002/09/15):
   	+ Fixed a few bugs in xdvi-search.el (thanks to Reiner Steib
 	  for spotting them, and suggesting patches)
	+ Merged in changes for libs and configure from teTeX-beta
	  (had been planned only for HEAD, but the situation became
	  too messy) - thanks to Thomas Esser for the great work in
	  teTeX that made this much easier ;-)
	  This means that --with-system-wwwlib and --with-system-t1lib
	  now finally work properly.
	+ Removed K&R compatibility macros to address bugs with gcc 3.2
	  on Solaris, and simplify the setup.
	  Users who really need K&R support should look at Paul Vojta's
	  version of xdvi instead: http://math.berkeley.edu/~vojta/xdvi.html
	+ Added progress indicator for file downloads

   * 22.40m (2002/09/14):
        + Same as 22.40n, except that the depend.mk file had contained
	  references to locally installed libwww headers that had made it
	  unusable.
	  For that reason, 22.40m was withdrawn and replaced by 22.40n.

   * 22.40l (2002/09/01):
	+ Fixed a memory leak (#599082, discovered and patched by
          Nobuyuki Tsuchimura)
	+ Updated configure to deal with Mac OS X (bug #597977)
	+ Change rules for multiple entries in .map files: Now later entries
	  override previous ones, which is the same behaviour as dvips. Also,
	  xdvik now gives a warning if such a case occurs.
	+ Fixed a memory corruption bug that could occur when
	  switching from a file for which PK font creation failed to
	  another file in the file selection dialog
	+ Documentation changes and minor GUI changes (button positions,
	  re-introduce `First' and `Last' buttons that had been lost
	  in some previous change, de-iconify window on forward search)
	+ Fixed a bug with values <= 0 for the `+page' option causing
          xdvi to exit ungracefully (#601722, again discovered and patched by
	  Nobuyuki Tsuchimura)

   * 22.40k (2002/05/21):
	+ Fixed bug #559113 (segfault with large .map files)
	+ Fixed a bug in 22.40j with magnifier sometimes not
          appearing for files opened via the file selection dialog

   * 22.40j (2002/04/30):
	+ Fix the compatibility problems with Ghostview v.7.04 and
          7.20 (see the thread "xdvi 22.40i status" in the tex-k
          mailing list, and feature request #525127).
        + Fix bug #550357 that might cause segfaults when doing a forward
          search on a corrupted DVI file.
        + Replace grid1, grid2 and grid3 resources/options by
          rulecolor resource/option, and make grid and magnifier
          window use this resource.
        + Fix a typo in lucida.map (replaced 850 by .850)

   * 22.40i (2002/04/08):
	+ Fixed buffer overflow bug in hypertex.c that broke opening
	  a new xdvi instance with Mouse-2 on hyperlink
	  
   * 22.40h (2002/03/19):
	+ Removal of t1lib documentation and sample fonts reduces
	  package size from 3MB to 2MB.
        + Fix hyperref bugs #505100 and #473361, and a failed assertion
	  when starting a command (e.g. the EDITOR) fails with no output.
        + Additional configure options for xaw3d and neXtaw.

   * 22.40g (2002/01/08):   
 	+ Upgrade to t1lib v1.3.1. 
    	+ Fix bug with XInternAtoms not available in X11R5. 
    	+ Fix bug #478034 (shell escapes were incorrectly treated as URLs).
    	+ Fix bug #500386 (wrong scaling of faked small caps fonts). 
    	+ Don't exit with usage message when n in the `+n' command line
      	  option (for goto-page) exceeds the total number of pages, but go to
      	  the last page instead.

   * 22.40f (2001/11/02):
        + Updgrade to t1lib v1.2.
	+ Fix a t1lib rendering bug with mfmodes different from 600dpi (#474213).

   * 22.40e (2001/10/09):
        + fixed a serious bug in previous version: libwww_wrapper_HTLoadToFile
          (use of xfopen) caused an infinite recursion when saving a remote file
          to disk.
        + minor change in README files

   * 22.40d (2001/10/08):
        + Use libwww_wrapper_HTLoadToFile to make xdvik more immune to libwww bugs
          and interface changes.

   * 22.40c (2001/08/06):
        + Fix some T1 font sizing problems when switching between
          documents (#441029, #443743)
        + Fix a memory leak with popup windows
        + Fix a libwww bug (segfault with invalid URIs, #434836)
        + Improve error messages when fetching remote files fails
   * 22.40b (2001/06/18):
        + Fix bug with popup windows causing BadMatch X errors
     	  under certain color settings (reported by T. Esser; patch from
     	  xdvi-22.42).
   * 22.40a (2001/06/07):
        + Speed up T1 font loading by disabling afm files.
        + Change .enc file handling to use same format as dvips
          (requires update of xdvi.cfg).
        + Fix a bug with `OK' button not working when several popups
          are active.
   * 22.40 (2001/06/01):
	+ Fix some segfaults with font generation and popup
     	  windows on Solaris (thanks to T. Esser for reporting and helping
     	  to fix).
   * 22.39 (2001/05/28):
        + Direct rendering of T1 Postscript(TM) fonts with t1lib.
        + Source special support (forward + backward search) as in
          xdvi.
        + New GUI elements: statusline, message windows, help window.
        + New event and action handling (from xdvi), with configurable
          buttons.
        + New actions: drag canvas with mouse, smooth scrolling with
          arrow keys, and minor adjustments of other actions.
        + Minor changes in hyperref and mime handling code to make it
          more robust.
   * 22.15 (1999/08/22):
 	+ Compiles and works on SunOS 4.
   * 22.08c (1999/06/15):
	+ The message 'Not a DVI file' accompanied by
     	  xdvi terminating should be a lot more rare now. The mime-typing
     	  and href mechanism was fixed somewhat.
   * 22.08b (1999/06/12):
	+ Compressed PS files on more than one page
     	  works better. Gets rid of /tmp/xdviXXXXX0: file exists messages
     	  and the wrong PS graphics on the wrong page.
   * 22.08 (1999/06/11):
	+ The "Help" button reappears.
   * 22.05b (8/5/1999):
	+ Prototype and variable declaration fixups.
   * 22.04 (1999/02/11):
	+ Adapt cleanup code to the k version. xdvik uses
     	  a directory for tmp files, xdvi does not. Other tmp file cleanups;
     	  it should be possible to access documents with more than 3
     	  included figures by http now.
   * 22.01 (1999/02/15):
	Beta release again.
        + Fix for (rare?) file-descriptor overflow.
        + Fix for compilation warning about urlocalize
        + Added `tags' target in top Makefile
        + 22 would always use the antialiasing device of gs. Fixed.
   * 22 (1999/02/05):
	+ Stable release. Sync with Paul Vojtas xdvi-22.
     	  There are no functional changes since the last release, only some
     	  tidying up.

 Changes made during the xdvik-21 cycle:
   * Documentation updates
   * Numerous porting enhancements: In particular native and addon CCs
     of AIX, HP-UX and Solaris now works.
   * Several small cosmetical fixes.
   * Clearification of copyright and licesing terms in documentation
     and --version information.
   * The percent lables on the shrink buttons are back. They also have
     good shrink factors for both 300 and 600 dpi resolutions. Anyone
     using 1200 dpi fonts with xdvi are welcome to contribute a patch
     for that.
   * Percent labels on user specified shrink buttons.
   * Got rid of SIGSEGV when showing figures in dvi files whose path
     contains / (ie. other than in .)
   * Got rid of SIGSEGV when showing figures in remote (http:, ftp:)
     files. Doing
       xdvi http://www.math.uio.no/~janl/tex/tex.dvi
     now works, with figures and all. Except if they're compressed.
   * On IRIX and DEC-Unix, if your X libs are in a nonstandard place,
     so that -L/path/X11 is needed, you also need -Wl,-rpath,/path/X11.
     Autoconf already supported Solaris' -R.
   * The Reopen button and automatic redisplay when the dvi file was
     updated was broken. This will also make it reopen web retrived
     files. If it will serve as the reload button in a WWW browser is
     another matter entierly though.
   * xdvi could not open the old file if Cancel was selected in the
     selfile dialogue.
   * The filename returned from the selfile dialogue was not being
     URLized as it should.
   * Use tempnam(3) to generate temporary directory name
   * Reorganized to same hierarchy as upcomming teTeX 0.9 and tex-k 7.3
     releases, by Thomas Esser.
   * Update of libwww and kpathsea also by Thomas Esser.
   * The shrink buttons work better. Patch by Keith Refson.
   * Missing / in xfilepath in xdvi-sh
   * Omega xdvik compilation problems fixed
   * Selfile fix from Dr. Werner Fink helps the CANCEL button to work.
   * mime.c patch from Allin Cottrell makes hypertex browsing more
     reliable.
   * xdvik always assumed that #foo is a URL fragment reference and
     removed it unconditionaly. Emacs uses # as temporary file prefix
     (and infix) and so emacs' TeX mode produced .tex and thus .dvi
     files with # in the name. Problem found by many and solutions
     suggested by many. Only remove #foo if the dvi name is an URL. To
     open local files you had better not use URL format ;-)
   * xdvik 21.21 was produced from xdvik 20c and xdvi-21.21. Two whole
     days of work to get the merge sane.
